#
# this tiny script has been created by caminoix, 2007.01.28 (v0.1)
#
#
# in case you were interested, some nice links here:
# my homepage - has been "in a very early construction phase" for a very long time now; probably not going to change soon... -
#		http://www.caminoix.prv.pl/
# nemerle - a great programming language for mono (.net in windows) - http://nemerle.org/Main_Page
# kate os - sth like a much improved slackware - http://www.kateos.org/
#
#
# version 0.2 (2007.02.07)
# - added counting the number of items
# - added the possibility to change the place where the listing is written to (see below)
# - some minor changes to the code
#
#
# hope you'll find this menu useful :)
#
#!/bin/bash

for thisDir in $@; do
	#
	# change the outputDir line below to wherever you want the listing to be written to
	# it doesn't matter if the path you enter ends with a "/" or not
	# example: outputDir="/home/kamil/listings"
	outputDir="${thisDir%/*}/"
	#
		
	dirCount=0
	dirList=""
	fileCount=0
	fileList=""
	lnkCount=0
	lnkList=""
	
	for i in $thisDir/*; do
		fileName=${i##*/}
		if [ -h $i ]; then
			let "lnkCount=$lnkCount+1"
			target=`ls -l $i | gawk '{ print $11 }'`
			lnkList="$lnkList\n$fileName -> $target"
		elif [ -d $i ]; then
			let "dirCount=$dirCount+1"
			dirList="$dirList\n$fileName"
		elif [ -f $i ]; then
			let "fileCount=$fileCount+1"
			fileList="$fileList\n$fileName"
		fi
	done
	
	lnkList="LINKS ($lnkCount):$lnkList"
	dirList="DIRECTORIES ($dirCount):$dirList"
	fileList="FILES ($fileCount):$fileList"
	
	finalList="#\n# LISTING OF $thisDir\n#"
	if [ $dirCount != 0 ]; then finalList="$finalList\n\n$dirList"; fi
	if [ $fileCount != 0 ]; then finalList="$finalList\n\n$fileList"; fi
	if [ $lnkCount != 0 ]; then finalList="$finalList\n\n$lnkList"; fi
	
	echo -e $finalList > "${outputDir%/}/${thisDir##/*/}.list.txt"
done